//
// Source: fri13.bas
// Translated from Basic to C++ using btran(~tm:)
// on Monday, July 10, 2000 at 12:11:03
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"
#include "datalist.h"



//
// Function Prototypes
//
static Int32 fnmod_7(Int32 x);

//
// Data Statement
//
static const char* DataValue[] = {
	"Jan","Feb","Mar","Apr","May","Jun",
	"Jul","Aug","Sep","Oct","Nov","Dec", NULL};
DataListClass DataList(DataValue);

static Int32 fnmod_7(Int32 x)
{
	Int32 Result;

	Result = x - x / 7 * 7;
	return Result;
}

int basic_main()
{
	Int32 end_year;
	Int32 end_year_default;
	Int32 feb;
	Int32 first_day;
	Int32 friday_13;
	Int32 i;
	Int32 last_year;
	Int32 leap;
	Int32 month_V1;
	Int32 start_year;
	Int32 start_year_default;
	Int32 sunday;
	BString year;
	Int32 year_V2;

	BString month[13];
	Int32 days[13];
	//	Counts the number of Friday the 13ths in a particular year
	//
	//	Creation date:  13-Jul-79  (Friday the 13th)
	//
	//	Franklin Mitchell
	//	Computer Operations Supervisor
	//	Erskine College
	//	PO Box 86 F
	//	Due West, South Carolina 29639
	for (i = 1; i <= 12; i++)
	{
		DataList.Read(month[i]);
	}
	for (i = 1; i <= 12; i++)
	{
		days[i] = 31;
	}
	days[4] = days[6] = days[9] = days[11] = 30;
	feb = 2;
	sunday = 0;
L_1070:;
	BasicChannel[0] << endl;
	start_year_default = 1900 + atof(right(Qdate(0), 8));
	BasicChannel[0] << "Start with what year #" << Qnum1(start_year_default) << "#";
	BasicChannel[0] >> start_year;
	if (start_year <= 0)
	{
		start_year = start_year_default;
	}
	if (start_year < 100)
	{
		start_year = start_year + 1900;
	}
	if (start_year < 1584)
	{
		BasicChannel[0] << endl;
		BasicChannel[0] << "Sorry, I only work for years 1584 and above." << endl;
		goto L_1070;
	}
	BasicChannel[0] << endl;
	end_year_default = start_year + 10;
	BasicChannel[0] << "  End with what year #" << Qnum1(end_year_default) << "#";
	BasicChannel[0] >> end_year;
	if (end_year <= 0)
	{
		end_year = end_year_default;
	}
	if (end_year < 100)
	{
		end_year = end_year + 1900;
	}
	for (i = 1; i <= 3; i++)
	{
		BasicChannel[0] << endl;
	}
	BasicChannel[0] << "**** Friday the 13ths ****    BEWARE!" << endl;
	BasicChannel[0] << endl;
	for (year_V2 = start_year; year_V2 <= end_year; year_V2++)
	{
		BasicChannel[0] << endl;
		year = right(Qnum1(year_V2), 3);
		friday_13 = 0;
		last_year = year_V2 - 1;
		first_day = fnmod_7(last_year + last_year / 4 - last_year / 100 + last_year / 400 + 1);
		leap = 0;
		if (year_V2 / 4 == year_V2 / 4. && (year_V2 / 100 != year_V2 / 100. || year_V2 / 400 == year_V2 / 400.))
		{
			leap = 1;
		}
		days[feb] = 28 + leap;
		//
		//	If the 1st day of the month is Sunday, the 13th day = Friday
		for (month_V1 = 1; month_V1 <= 12; month_V1++)
		{
			if (fnmod_7(first_day) == sunday)
			{
				BasicChannel[0] << "13-" << month[month_V1] << "-" << year << '\t';
				friday_13 = friday_13 + 1;
			}
			first_day = fnmod_7(days[month_V1] + first_day);
		}
;
		BasicChannel[0] << BasicChannel[0].Tab(44) << friday_13 << "in " << Qnum1(year_V2) << "." << endl;
	}

	return EXIT_SUCCESS;
}
