//
// Source: putest.bas
// Translated from Basic to C++ using btran(~tm:)
// on Monday, July 10, 2000 at 12:11:03
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"
#include <pusing.h>

static PUsing PUse;	// Needed for print using


//
// Function Prototypes
//


int basic_main()
{

	BasicChannel[0] << "Numeric formats" << endl;
	PUse.SetFormat("1. ######.###### 1.");
	BasicChannel[0] << PUse.Output(123.456);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("1. ######.###### 1.");
	BasicChannel[0] << PUse.Output(-123.456);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("2. ######.#####- 2.");
	BasicChannel[0] << PUse.Output(123.654);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("3. ######.#####- 3.");
	BasicChannel[0] << PUse.Output(-123.654);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("4. **$$##.#####- 1.");
	BasicChannel[0] << PUse.Output(123.456);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("4. **$$##.#####- 1.");
	BasicChannel[0] << PUse.Output(-123.456);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("5. <0>#####.#####- 3.");
	BasicChannel[0] << PUse.Output(123.654);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("6. <%>#####.#####- 3.");
	BasicChannel[0] << PUse.Output(123.654);
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("6. <%>#####.#####- 3.");
	BasicChannel[0] << PUse.Output(0.0);
	BasicChannel[0] << PUse.Finish() << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Format with small text" << endl;
	BasicChannel[0] << Format("Test", "1. 'LLLLLLLLLLL 1.") << endl;
	BasicChannel[0] << Format("Test", "2. 'CCCCCCCCCCC 2.") << endl;
	BasicChannel[0] << Format("Test", "3. 'RRRRRRRRRRR 3.") << endl;
	BasicChannel[0] << Format("Test", "4. 'E 4.") << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Format with large text" << endl;
	BasicChannel[0] << Format("TestintTestingTesting", "1. 'LLLLLLLLLLL 1.") << endl;
	BasicChannel[0] << Format("TestintTestingTesting", "2. 'CCCCCCCCCCC 2.") << endl;
	BasicChannel[0] << Format("TestintTestingTesting", "3. 'RRRRRRRRRRR 3.") << endl;
	BasicChannel[0] << Format("TestintTestingTesting", "4. 'E 4.") << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Print Using Old Format" << endl;
	PUse.SetFormat("1. ! 1.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("2. /          / 2.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("3. /          / 3.");
	BasicChannel[0] << PUse.Output("TestingTestingTesting");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("4. 'E 4.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Print Using with small text" << endl;
	PUse.SetFormat("1. 'LLLLLLLLLLL 1.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("2. 'CCCCCCCCCCC 2.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("3. 'RRRRRRRRRRR 3.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("4. 'E 4.");
	BasicChannel[0] << PUse.Output("Test");
	BasicChannel[0] << PUse.Finish() << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Print Using with large text" << endl;
	PUse.SetFormat("1. 'LLLLLLLLLLL 1.");
	BasicChannel[0] << PUse.Output("TestingTestingTesting");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("2. 'CCCCCCCCCCC 2.");
	BasicChannel[0] << PUse.Output("TestingTestingTesting");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("3. 'RRRRRRRRRRR 3.");
	BasicChannel[0] << PUse.Output("TestingTestingTesting");
	BasicChannel[0] << PUse.Finish() << endl;
	PUse.SetFormat("4. 'E 4.");
	BasicChannel[0] << PUse.Output("TestingTestingTesting");
	BasicChannel[0] << PUse.Finish() << endl;

	return EXIT_SUCCESS;
}
