//
// Source: rotate.bas
// Translated from Basic to C++ using btran(~tm:)
// on Monday, July 10, 2000 at 12:11:04
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"
#include <pusing.h>

static PUsing PUse;	// Needed for print using


//
// Function Prototypes
//


int basic_main()
{
	BString a;
	double g;
	double i;
	double j;
	double m;
	double m1;
	double s;
	BString t;
	double x;
	double y;

	BStack(20);
	double b_V1[17];
	BString b[17];
	BasicChannel[0] << "GAME OF 'ROTATE' BY DAVE AHL.  ENJOY !!" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "INSTRUCTIONS (Y OR N)";
	BasicChannel[0] >> a;
	BasicChannel[0] << endl;
	if (a == "N")
	{
		goto L_140;
	}
	BasicChannel[0] << "IN THIS GAME THE BOARD IS LAID OUT AS FOLLOWS:" << endl;
	srand(time(0));
	for (i = 1; i <= 16; i++)
	{
		b_V1[(Int32)(i)] = i;
	}
	BasicChannel[0] << endl;
	for (i = 1; i <= 13; i += 4)
	{
		PUse.SetFormat("##  ##  ##  ##");
		BasicChannel[0] << PUse.Output(b_V1[(Int32)(i)]);
		BasicChannel[0] << PUse.Output(b_V1[(Int32)(i + 1)]);
		BasicChannel[0] << PUse.Output(b_V1[(Int32)(i + 2)]);
		BasicChannel[0] << PUse.Output(b_V1[(Int32)(i + 3)]);
		BasicChannel[0] << PUse.Finish() << endl;
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << "BOARD POSITIONS ARE OCCUPIED RANDOMLY BY THE LETTERS A TO P." << endl;
	BasicChannel[0] << "THE OBJECT OF THE GAME IS TO ORDER THE LETTERS BY ROTATING" << endl;
	BasicChannel[0] << "ANY FOUR LETTERS CLOCKWISE ONE POSITION.  YOU SPECIFY THE" << endl;
	BasicChannel[0] << "UPPER LEFT POSITION OF THE FOUR YOU WISH TO ROTATE, I.E.," << endl;
	BasicChannel[0] << "VALID MOVES ARE 1, 2, 3, 5, 6, 7, 9, 10, AND 11." << endl;
	BasicChannel[0] << "CONSEQUENTLY, IF THE BOARD LOOKED LIKE:" << endl;
	for (i = 1; i <= 16; i++)
	{
		b[(Int32)(i)] = Char(i + 64);
	}
	b[2] = "C";
	b[3] = "G";
	b[6] = "B";
	b[7] = "F";
	BGosub(L_400);
	BasicChannel[0] << "AND YOU ROTATED POSITION 2, THE BOARD WOULD BE:" << endl;
	for (i = 2; i <= 7; i++)
	{
		b[(Int32)(i)] = Char(i + 64);
	}
	BGosub(L_400);
	BasicChannel[0] << "AND YOU WOULD WIN !" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "YOU ALSO GET ONE 'SPECIAL' MOVE PER GAME WHICH YOU MAY OR" << endl;
	BasicChannel[0] << "MAY NOT NEED.  THE SPECIAL MOVE ALLOWS YOU TO EXCHANGE" << endl;
	BasicChannel[0] << "ANY TWO ADJACENT LETTERS IN A ROW.  TO MAKE THIS MOVE," << endl;
	BasicChannel[0] << "INPUT A '-1' AS YOUR MOVE AND YOU WILL BE ASKED FOR THE" << endl;
	BasicChannel[0] << "POSITIONS OF THE TWO LETTERS TO EXCHANGE.  REMEMBER -- " << endl;
	BasicChannel[0] << "ONLY ONE SPECIAL MOVE PER GAME!" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "TO GIVE UP AT ANY TIME, TYPE A '0'." << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "GOOD LUCK !" << endl;
	BasicChannel[0] << endl;
L_140:;
	for (i = 1; i <= 16; i++)
	{
		b[(Int32)(i)] = "0";
	}
	for (i = 1; i <= 16; i++)
	{
L_160:;
		t = Char(floor(16 * floatrand() + 65));
		for (j = 1; j <= i; j++)
		{
			if (b[(Int32)(j)] == t)
			{
				goto L_160;
			}
		}
		b[(Int32)(i)] = t;
	}
	m = 0;
	s = 0;
	BasicChannel[0] << "HERE'S THE STARTING BOARD..." << endl;
	BGosub(L_400);
L_200:;
	BasicChannel[0] << "POSITION TO ROTATE";
	BasicChannel[0] >> i;
	if (i == 0)
	{
		BasicChannel[0] << endl;
		BasicChannel[0] << endl;
		goto L_140;
	}
	if (i == -1)
	{
		goto L_510;
	}
	if (i == 4 || i == 8 || i > 12)
	{
		BasicChannel[0] << "ILLEGAL.  AGAIN..." << endl;
		goto L_200;
	}
	m = m + 1;
	t = b[(Int32)(i)];
	b[(Int32)(i)] = b[(Int32)(i + 4)];
	b[(Int32)(i + 4)] = b[(Int32)(i + 5)];
	b[(Int32)(i + 5)] = b[(Int32)(i + 1)];
	b[(Int32)(i + 1)] = t;
	//*** PRINT BOARD

L_240:;
	BGosub(L_400);
	//*** DO WE HAVE A WINNER?

	for (i = 1; i <= 16; i++)
	{
		if (Char(i + 64) != b[(Int32)(i)])
		{
			goto L_200;
		}
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << "YOU ORDERED THE BOARD IN" << m << "MOVES." << endl;
	m1 = m1 + m;
	g = g + 1;
	for (i = 1; i <= 15; i++)
	{
		BasicChannel[0] << Char(7);
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << "PLAY AGAIN (Y OR N)";
	BasicChannel[0] >> a;
	if (a == "Y")
	{
		goto L_140;
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << "YOU PLAYED" << g << "GAMES AND ORDERED THE BOARD IN AN AVERAGE" << endl;
	BasicChannel[0] << "OF" << m1 / g << "MOVES PER GAME." << endl;
	BasicChannel[0] << endl;
	goto L_999;
	//*** PRINT BOARD SUBROUTINE

L_400:;
	BasicChannel[0] << endl;
	for (i = 1; i <= 13; i += 4)
	{
		BasicChannel[0] << b[(Int32)(i)] << " " << b[(Int32)(i + 1)] << " " << b[(Int32)(i + 2)] << " " << b[(Int32)(i + 3)] << endl;
	}
	BasicChannel[0] << endl;
	BReturn;

	//*** SPECIAL MOVE SUBROUTINE

L_510:;
	BasicChannel[0] << "EXCHANGE WHICH TWO POSITIONS";
	BasicChannel[0] >> x >> y;
	if (x != y + 1 && x != y - 1)
	{
		BasicChannel[0] << "ILLEGAL.  AGAIN..." << endl;
		goto L_510;
	}
	s = s + 1;
	if (s > 1)
	{
		BasicChannel[0] << "ONLY ONE SPECIAL MOVE PER GAME." << endl;
		goto L_200;
	}
	t = b[(Int32)(x)];
	b[(Int32)(x)] = b[(Int32)(y)];
	b[(Int32)(y)] = t;
	goto L_240;
L_999:;

	return EXIT_SUCCESS;
}
