//
// Source: rad50.bas
// Translated from Basic to C++ using btran(~tm:)
// on Monday, July 10, 2000 at 12:11:03
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"



//
// Function Prototypes
//
static Int32 fnrad50(BString s);


static Int32 fnrad50(BString s)
{
	Int32 Result;
	Int32 i;
	Int32 illegalcharacter;
	Int32 s_V1;
	Int32 t;

	t = 0;
	for (i = 1; i <= 3; i++)
	{
		s_V1 = Ascii(left(s, 1));
		s = right(s, 2);
		if (65 <= s_V1 && s_V1 <= 90)
		{
			s_V1 = s_V1 - 64;
			goto L_8175;
		}
		if (48 <= s_V1 && s_V1 <= 57)
		{
			s_V1 = s_V1 - 18;
			goto L_8175;
		}
		if (s_V1 == 32)
		{
			s_V1 = 0;
			goto L_8175;
		}
		if (s_V1 == 36)
		{
			s_V1 = 27;
			goto L_8175;
		}
		if (s_V1 == 46)
		{
			s_V1 = 28;
			goto L_8175;
		}
		if (s_V1 == 63)
		{
			s_V1 = 29;
			goto L_8175;
		}
		illegalcharacter = -1;
		Result = 0;
		goto L_8190;
L_8175:;
		t = t * 40 + s_V1;
	}
	Result = t;
L_8190:;
	return Result;
}

int basic_main()
{
	BString s;

	// copies thereof
	// may  be provided  or otherwise  made  available  to any  other
	// person.   No title to and  ownership of the software is hereby
	// transferred.
	//
	// The information in this  software is subject to change without
	// notice and should not be construed as a commitment by Whittier
	// College or the author.
	//
	// Whittier  College  assumes  no  responsibility  for the use or
	// reliability  of its software on equipment that is not supplied
	// by Whittier College.  Whittier College supplies no equipment.
	//
	//***************************************************************
	//
	//
	//    This program was written for internal use and has not
	// been significantly modified for export.  You may need to make
	// changes to fit your system or needs.  If you have any problems
	// please contact:
	//
	//    David Garland
	//    Whittier College
	//    Whittier CA 90601
	//    (213) 693-0771 ext 289
	//
	//
	//			RAD50
	//
	// A program to demonstrate a function to convert a string to
	// RAD50.  The built-in function RAD$ will convert from RAD50.
	// The file name string scan function can be used to convert to
	// RAD50, but can't convert strings which have periods in them.
	//
	//
	//     Pedantic lecture:
	//
	//    "Radix" is a mathematic term for "base", as in "base 2"
	// ( = binary) or "base 8" ( = octal).  There are 40(decimal)
	// characters in RAD50.  Each one is considered as a "digit" in
	// base 40(decimal).  A group of three characters is regarded as
	// a three digit number in base 40 and converted to decimal.  The
	// decimal valuee is the RAD50 value of the string.  Note that the
	// largest possible number which need be stored is 40 ^ 3 - 1 =
	// 63999.  41 characters would require numbers as large as 68920,
	// too big for 16 bits.  Numbers larger than 63999 do not
	// correspond to any string.
	//    The point of this discussion is that the correct
	// pronunciation of RAD50 is "radix fourty" or "radix five zero",
	// not "radix fifty".  Note that 50(octal) = 40(decimal)
	//
	//
	// Get a string
	//
L_100:;
	BasicChannel[0] << "String to convert (<= 3 characters)";
	BasicChannel[0] >> s;
	s = edit(s, 4);
	if (s == "")
	{
		goto L_900;
	}
	s = left(s + "   ", 3);
	//
	// Print converted form and convert back
	//
	BasicChannel[0] << fnrad50(s) << '\t' << Qrad(fnrad50(s)) << endl;
	//
	// go back
	//
	goto L_100;
	//
	// done
	//
L_900:;
	goto L_32767;
	//
	//
	//	FUNCTIONS
	//
	//
	//
	// convert three character string to RAD50
	// illegal characters are changed to blanks and a flag is set
	//
L_32767:;

	return EXIT_SUCCESS;
}
