//
// Source: revrse.bas
// Translated from Basic to C++ using btran(~tm:)
// on Monday, July 10, 2000 at 12:11:03
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"



//
// Function Prototypes
//


int basic_main()
{
	BString a;
	double g;
	double j;
	double k;
	double n;
	double r;
	double t;
	double t1;
	double z;

	BStack(20);
	double a_V1[21];
	//*** REVERSE WRITTEN BY BOB ALBRECHT, PEOPLE'S COMPUTER CO
	//*** MODIFIED AND CONVERTED TO BASIC-PLUS BY DAVID AHL
	BasicChannel[0] << endl;
	BasicChannel[0] << "REVERSE -- A GAME OF SKILL" << endl;
	BasicChannel[0] << endl;
	srand(time(0));
	//*** N=NUMBER OF NUMBERS
	n = 9;
	g = 0;
	t1 = 0;
	BasicChannel[0] << "DO YOU WANT THE RULES (YES OR NO)";
	BasicChannel[0] >> a;
	if (a == "NO")
	{
		goto L_210;
	}
	BGosub(L_710);
	//*** MAKE A RANDOM LIST A(1) TO A(N)
L_210:;
	a_V1[1] = floor((n - 1) * floatrand()) + 2;
	for (k = 2; k <= n; k++)
	{
L_230:;
		a_V1[(Int32)(k)] = floor(n * floatrand()) + 1;
		for (j = 1; j <= k - 1; j++)
		{
			if (a_V1[(Int32)(k)] == a_V1[(Int32)(j)])
			{
				goto L_230;
			}
		}
	}
	//*** PRINT ORIGNIAL LIST AND START GAME
	BasicChannel[0] << endl;
	BasicChannel[0] << "HERE WE GO ... THE LIST IS:" << endl;
	t = 0;
	BGosub(L_610);
L_330:;
	BasicChannel[0] << "HOW MANY SHALL I REVERSE";
	BasicChannel[0] >> r;
	if (r == 1)
	{
		BasicChannel[0] << "OOPS!  ONE DOESN'T DO ANYTHING.  AGAIN..." << endl;
		goto L_330;
	}
	if (r == 0)
	{
		goto L_530;
	}
	if (r <= n)
	{
		goto L_390;
	}
	BasicChannel[0] << "OOPS! TOO MANY - I CAN REVERSE AT MOST" << n << endl;
	goto L_330;
L_390:;
	t = t + 1;
	//*** REVERSE R NUMBERS AND PRINT NEW LIST
	for (k = 1; k <= floor(r / 2); k++)
	{
		z = a_V1[(Int32)(k)];
		a_V1[(Int32)(k)] = a_V1[(Int32)(r - k + 1)];
		a_V1[(Int32)(r - k + 1)] = z;
	}
	BGosub(L_610);
	//*** CHECK FOR A WIN
	for (k = 1; k <= n; k++)
	{
		if (a_V1[(Int32)(k)] != k)
		{
			goto L_330;
		}
	}
	BasicChannel[0] << "YOU WON IT IN" << t << "MOVES !!!" << endl;
	BasicChannel[0] << endl;
	g = g + 1;
	t1 = t1 + t;
L_530:;
	BasicChannel[0] << "TRY AGAIN (YES OR NO)";
	BasicChannel[0] >> a;
	if (a == "YES")
	{
		goto L_210;
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << "YOU PLAYED" << g << "GAMES AND REVERSED THE LISTS IN AN" << endl;
	BasicChannel[0] << "AVERAGE OF" << t1 / g << "MOVES PER GAME.  HOPE YOU HAD FUN!" << endl;
	goto L_999;
	//*** SUBROUTINE TO PRINT LIST
L_610:;
	BasicChannel[0] << endl;
	for (k = 1; k <= n; k++)
	{
		BasicChannel[0] << a_V1[(Int32)(k)];
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << endl;
	BReturn;

	//*** SUBROUTINE TO PRINT THE RULES
L_710:;
	BasicChannel[0] << endl;
	BasicChannel[0] << "THIS IS THE GAME OF 'REVERSE'. TO WIN, ALL YOU HAVE" << endl;
	BasicChannel[0] << "TO DO IS ARRANGE A LIST OF NUMBERS (1 THROUGH" << n << ")" << endl;
	BasicChannel[0] << "IN NUMERICAL ORDER FROM LEFT TO RIGHT. TO MOVE, YOU" << endl;
	BasicChannel[0] << "TELL ME HOW MANY NUMBERS (COUNTING FROM THE LEFT) TO" << endl;
	BasicChannel[0] << "REVERSE. FOR EXAMPLE, IF THE CURRENT LIST IS:" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "2 3 4 5 1 6 7 8 9" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "AND YOU REVERSE 4, THE RESULT WILL BE:" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "5 4 3 2 1 6 7 8 9" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "NOW, IF YOU REVERSE 5, YOU WIN!" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "1 2 3 4 5 6 7 8 9" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "NO DOUBT YOU WILL LIKE THIS GAME OF SKILL, BUT" << endl;
	BasicChannel[0] << "IF YOU WANT TO QUIT, REVERSE 0 (ZERO)." << endl;
	BasicChannel[0] << endl;
	BReturn;

L_999:;

	return EXIT_SUCCESS;
}
