// datalist.h
//
//	Handle 'DATA' statements.
//
// History
//
//	04/10/2000 - Kevin Handy
//		Don't duplicate array of pointers. Use somple pointer
//		instead.
//
class DataListClass
{
private:
	int count;
	const char** Values;

public:
	DataListClass() { count = 0; }
	DataListClass(const char* List[])
		{ Values = List; count = 0; }
	~DataListClass() {}

	void Read(double& result) { result = atof(Values[count++]); }
//	void Read(char*& result) { result = Values[count++]; }
	void Read(int& result) { result = atoi(Values[count++]); }
	void Read(long& result) { result = atol(Values[count++]); }
	void Read(BString& result) { result = Values[count++]; }
	void Reset() { count = 0; }
};

